﻿/**

  The Initial Developer of the Original Code is
  Matthieu  - http://www.actionscript-facile.com
  Portions created by the Initial Developer are Copyright (C) 2010
  the Initial Developer. All Rights Reserved.

  Contributor(s) :

 */
package
{
	import com.as3facile.DefaultButton;

	import flash.events.MouseEvent;
	import flash.geom.ColorTransform;
	import flash.display.DisplayObject;
	
	import com.demonsters.debugger.MonsterDebugger;
	
	import flash.events.Event;
	import flash.display.Sprite;
	
	
	
	// definit la couleur de fond du swf
	[SWF(backgroundColor="0xffffff")] 

	public class Main extends Sprite
	{
		private var oBtnStartGame : DefaultButton;
		private var oIcon : Icone;
		private var oIcon2 : Icone;
		
		

		/**
		 * Constructeur.
		 * 
		 * Compiler avec le SDK Flex 4.6
		 * 
		 * -swf-version = 18 : pour l'API Flash Player 11.5
		 * -default-frame-rate 40 : nombre d'images par secondes
		 * 
		 */
		public function Main()
		{
			// attend la fin de l'initialisation de la scène
			this.addEventListener(Event.ADDED_TO_STAGE, onReady, false, 0, true);
		}

		/**
		 * Démarrage de l'application.
		 * définit le nombre d'images par secondes dans les paramètres de compilation
		 * 
		 * 
		 */
		private function onReady(event : Event) : void
		{
			this.removeEventListener(Event.ADDED_TO_STAGE, onReady);
			
			// Init De MonsterDebugger
			MonsterDebugger.initialize(this);
			MonsterDebugger.trace(this, "Start transparence color");
			
			this.buildUI();
		}


		/**
		 * Construit l'affichage de l'application.
		 * 
		 * 
		 */
		private function buildUI() : void
		{ 	
			oIcon = new Icone();
			oIcon.x = 50;
			oIcon.y = 30;
			oIcon.scaleX = 0.6;
			oIcon.scaleY = 0.6;
			this.addChild(oIcon);	
			
			
			oIcon2 = new Icone();
			oIcon2.x = 350;
			oIcon2.y = 69;
			oIcon2.scaleX = 0.3;
			oIcon2.scaleY = 0.3;
			this.addChild(oIcon2);
			
			// Création du bouton pour le menu contextuel
			oBtnStartGame = new DefaultButton();
			oBtnStartGame.getObject().label = "Nouvelle Couleur !";
			oBtnStartGame.getObject().x = stage.stageWidth - oBtnStartGame.width - 40;
			oBtnStartGame.getObject().y = 33;
			oBtnStartGame.getObject().addEventListener ( MouseEvent.CLICK, onChangeColor );
			this.addChild(oBtnStartGame);
		}
		
		
		
	

		/**
		 * Appel lors du clic sur le bouton.
		 * 
		 */
		private function onChangeColor(event : MouseEvent) : void 
		{
			this.changeColor(oIcon.clip.color);// récupère le Sprite nommé color
			this.changeColor(oIcon2.clip.color);// récupère le Sprite nommé color
		}
		
		
		/**
		 * Change aléatoirement la couleur d'un display object.
		 * 
		 */
		private function changeColor(oDisplay:DisplayObject) : void
		{
			// définit les couleurs primaires aléatoirement
			var red:int = int(Math.random() * 255);
			var green:int = int(Math.random() * 255);
			var blue:int = int(Math.random() * 255);
 
 			// construit la valeur hexadécimale de la couleur
			var hexValue:Number = Number("0x" + red.toString(16) + green.toString(16) + blue.toString(16));
			
			MonsterDebugger.trace(this, " ");
 			MonsterDebugger.trace(this, "valeur hexa : #"+hexValue.toString(16).toUpperCase() );// conversion de la valeur décimale en hexadécimal avec mise en majuscule
 			MonsterDebugger.trace(this, "valeur décimal : "+hexValue);
			
			// applique la couleur au Display Object
			var colorTransform:ColorTransform = new ColorTransform();
			colorTransform.color = hexValue;
			oDisplay.transform.colorTransform = colorTransform;
		}

	}
}
